Subject: Re: [PATCH v10 03/20] dlb: add resource and device initialization

From: Greg KH <[email-masked]>
Date: Wed, 10 Mar 2021 09:13:24 +0100

On Wed, Mar 10, 2021 at 01:33:24AM +0000, Chen, Mike Ximing wrote:
> 
> > -----Original Message-----
> > From: Greg KH <[email-masked]>
> > 
> > On Wed, Feb 10, 2021 at 11:54:06AM -0600, Mike Ximing Chen wrote:
> > > +
> > > +#include "dlb_bitmap.h"
> > > +
> > > +#define BITS_SET(x, val, mask)	(x = ((x) & ~(mask))     \
> > > +				 | (((val) << (mask##_LOC)) & (mask)))
> > > +#define BITS_GET(x, mask)       (((x) & (mask)) >> (mask##_LOC))
> > 
> > Why not use the built-in kernel functions for this?  Why are you
> > creating your own?
> >
> FIELD_GET(_mask, _val) and FIELD_PREP(_mask, _val) in include/linux/bitfield.h
> are similar to our BITS_GET() and BITS_SET().  However in our case, mask##_LOC
> is a known constant defined in dlb_regs.h,  so we don't need to use 
> _buildin_ffs(mask) to calculate the location of mask as FIELD_GET() and FIELD_PREP()
> do.  We can still use FIELD_GET and FIELD_PREP, but our macros are a little more 
> efficient. Would it be OK to keep them?

No, please use the kernel-wide proper functions, there's no need for
single tiny driver to be "special" in this regard.  If somehow the
in-kernel functions are not sufficient, it's always better to fix them
up than to go your own way here.

thanks,

greg k-h